library hipster_sync;
import 'dart:html';
import 'dart:convert';

class HipsterSync {
  static _defaultSync(method, model, {options}) {
    var req = new HttpRequest();
    _attachCallbacks(req, options);

    req.open(method, model.url);

    // POST and PUT HTTP request bodies if necessary
    if (method == 'post' || method == 'put') {
      req.setRequestHeader('Content-type', 'application/json');
      req.send(JSON.encode(model.attributes));
    }
    else {
      req.send();
    }
  }

  void elided_method() {
    // ...
  }


/* START:injected_sync
class HipsterSync {
  // ...
  END:fake_class_for_inclusion_in_book */
  static var _injected_sync;
  static set sync(fn) {
    _injected_sync = fn;
  }

  // delete the injected sync behavior
  static useDefaultSync() {
    _injected_sync = null;
  }

  // static method for HipsterModel and HipsterCollection to invoke -- will
  // forward the call to the appropriate behavior (injected or default)
/* START:static_call
class HipsterSync {
  // ...
  END:fake_class_for_inclusion_in_book */
  static send(method, model, {options}) {
    if (_injected_sync == null) {
      return _defaultSync(method, model, options:options);
    }
    else {
      return _injected_sync(method, model, options:options);
    }
  }
/* END:fake_class_for_inclusion_in_book
}
END:static_call */

  static _attachCallbacks(request, options) {
    if (options == null) return;
    if (options.containsKey('onLoad')) {
      request.onLoad.listen((event) {
        var req = event.target,
            json = JSON.decode(req.responseText);
        options['onLoad'](json);
      });
    }
  }
}
